package fr.enssat.BoulderDash.controllers;

import fr.enssat.BoulderDash.models.LevelModel;

import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;

public abstract class AbstractKeyController extends AbstractLevelController implements KeyListener {
  public AbstractKeyController(LevelModel levelModel) {
    super(levelModel);
  }

  /**
   * Handles the 'key pressed' event
   *
   * @param e Key event
   */
  public void keyPressed(KeyEvent e) {
    handleKey(e.getKeyCode());
    additionalSteps();
  }

  protected void handleKey(final int keyCode) {
    switch (keyCode) {
      case KeyEvent.VK_UP:
        up();
        break;
      case KeyEvent.VK_DOWN:
        down();
        break;
      case KeyEvent.VK_LEFT:
        left();
        break;
      case KeyEvent.VK_RIGHT:
        right();
        break;
      case KeyEvent.VK_SPACE:
        space();
        break;
      case KeyEvent.VK_SHIFT:
        shift();
        break;
    }
  }

  protected void up() {
  }

  protected void down() {
  }

  protected void left() {
  }

  protected void right() {
  }

  protected void space() {
  }

  protected void shift() {
  }


  protected void additionalSteps() {
  }

  /**
   * Handles the 'key released' event
   *
   * @param e Key event
   */
  @Override
  public void keyReleased(KeyEvent e) {
    // Do nothing.
  }

  /**
   * Handles the 'key typed' event
   *
   * @param e Key event
   */
  @Override
  public void keyTyped(KeyEvent e) {
    // Do nothing.
  }
}
